# Vivian ARCore Test Project

This repository contains a complete Unity project with the necessary modules for building a Vivian based application on compatible Android smartphones. Please check the compatibility list to determine whether your phone can run ARCore enabled applications: [ARCore supported devices](https://developers.google.com/ar/discover/supported-devices#android_play).

The necessary modules for running this project are contained within [Git Submodules](https://git-scm.com/book/en/v2/Git-Tools-Submodules). In order to get the project running, you will need to initialize the submodules (i.e. clone them within the project) as they are not cloned automatically upon cloning the main project.

## Initialize the Project

1. Clone the project and initialize the submodules.
+ In a GUI client, this can be proposed to you when cloning the project.
+ If you use Git through the CLI, run this command to have the submodules directly checked out:
`git clone --recurse-submodules https://gitlab.com/usability-engineering-ar-mr-vr/vivian-framework/vivian-arcore-test-project.git`

2. Download the matching version of Unity used for this project: **2019.1.10f1**. This can be done through Unity Hub.
+ Make sure to install the **Android build support** modules, including **OpenJDK**.
+ In order to build to Android 11, a more recent version of Gradle than the one provided is required. The minimal required version of Gradle is `v5.6.4` and can be downloaded here: https://gradle.org/releases/ To tell Unity to use the correct version of Gradle, go to *Edit > Preferences > External Tools*, then uncheck "Gradle installed with Unity, and indicate the path to the version you downloaded."

3. Add the cloned project into Unity Hub. Just navigate to the root folder and click **Select Folder**.

4. In Unity, go to *File > Build Settings...*, select **Android** in the platforms list, and click **Switch Platform**.

5. The different prototypes are configured within their respective scene (*Assets/Scenes*). The ARCore Test project also contains a main menu scene that can run the different scenes (this is the first scene in the build which will be started upon running the application). Note that this organisation will change in the future.

6. Build the prototypes' Asset Bundles: *Assets > Build Vivian Prototype Bundles*.

7. For understanding how prototypes are made, built, and used in the scenes, see the [Vivian Framework](#vivian-framework) section.

8. Build an Android application:
+ Without a phone connected: 'File > Build Settings... > Build' will build an APK that can be installed.
+ With a phone connected (make sure that USB debugging is enabled): 'File > Build Settings... > Build and Run' will directly install the APK on the phone and run the application.

## Vivian Framework

### Scene Hierarchy
Each scene contains a number of Game Objects that are necessary for running the application. The most important ones are described in the following.

##### VivianFramework
This prefab contains the **Virtual Prototype** script that takes two parameters: 
+ **Bundle URL**: local or remote URL that points to the prototype. A local URL can point to an [AssetBundle](#asset-bundles) or a folder from the **Vivian Example Prototypes/Resources** package. Valid examples (depending on selected URL, the prefab must be inside the folder or the asset bundle denoted by the URL):
  + AssetBundles/Android/coffeemachine
  + Microwave
+ **Prototype Prefab Name**: name of the prefab created after the prototype model. Prototypes usually contain two declinations of prefabs: one based on a blender source file (`.blend`), one based on the `.fbx` model file system. Valid examples:
  + microwave
  + coffeemachine2

 ##### ObjectPositioner
 This Game Object contains the **Object Positioner** script which is used to place the **Virtual Prototype** in the 3D space. It currently supports 3 methods of prototype placement:
 + Relative to Screen
 + Relative to Floor
 + Relative to Plane

These can be selected in the dropdown menu in the script parameters. The latest method, *Relative to Plane*, uses a number of ARCore prefabs, notably to visualize planes, and manipulate objets in the 3D space (see the [ARCore](#arcore) section). 

### Asset Bundles
Asset Bundles are archives generated by Unity. They are used in the Vivian Framework to contain the virtual prototypes' models, materials, functional specification, or any resources that are included in their *Example Prototype/Resources* folder (see the **Vivian Example Prototypes** submodule).

The creation of Asset Bundles is only required if you reference an Asset Bundle in the VivianFramework prefab. In case you reference a prototype directly from within the Resources folder in the **Vivian Example Prototypes** package, then the creation is not required.

To generate them, click *Assets > Build Vivian Prototype Bundles*. This creates an **AssetBundles** folder in the **Assets** folder, if it doesn't already exist. Another folder is created inside, depending on the build target, in our case, **Android**. The AssetBundles are contained here.

## ARCore
The ARCore SDK is included in the Vivian ARCore interaction package. For more information on using ARCore:
+ [HelloAR sample app](https://developers.google.com/ar/develop/unity/tutorials/hello-ar-sample)
+ [Object Manipulation sample app](https://developers.google.com/ar/develop/unity/tutorials/object-manipulation-sample)
